//+------------------------------------------------------------------+
//|                                                    expert-my.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
input long order_magic=55555;
#include<Trade\Trade.mqh>
#include<Trade\PositionInfo.mqh>
 

static datetime last_time=0;
 
CTrade  myTrade;
CPositionInfo myPositionInfo;

datetime counted_bar=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   counted_bar=0; //  ,       
   CheckNewBar();
//---
   return(INIT_SUCCEEDED);
  }
 
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---




   if(!isNewBar())
     {
      return;
     }

   if(!mag(1))
          BUY(1,0.1);

   if(PositionProfit(1)<-3)
      if(!mag(2))
         BUY(2,0.1);

   if(PositionProfit(2)<-3)
      if(!mag(3))
         BUY(3,0.1);



   if(PositionProfit(1)+PositionProfit(2)+PositionProfit(3)>5);
     {

      mPositionClose(1);
      mPositionClose(2);
      mPositionClose(3);

     }



  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                                     myscript.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+



void mPositionClose(int Magic)
  {
   CTrade mtrade;
   CPositionInfo pos;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;

      mtrade.PositionClose(pos.Identifier());

     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BUY(int magick,double volume)
  {

   MqlTick last_tick={0};
   SymbolInfoTick(_Symbol,last_tick);

//---   
   MqlTradeRequest request={0};
   request.action=TRADE_ACTION_DEAL;            //    
   request.magic=magick;                           // ORDER_MAGIC 
                                                   // request.order=2111;                          //   

   request.symbol=_Symbol;                      //  
   request.volume=volume;                          //   0.1  
   request.sl=0;                                // Stop Loss   
   request.tp=0;                                // Take Profit      
//---    
   request.type=ORDER_TYPE_BUY;                 //   
//---     
   request.price=last_tick.bid; //    Bid 
                                //    
//---    
   MqlTradeResult result={0};
   OrderSend(request,result);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PositionProfit(int Magic)
  {
   CTrade trade;
   CPositionInfo pos;
   double prof;
   prof=0;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;
      // if(pos.Profit()>=Profit)
      //  {
      //    trade.PositionClose(pos.Identifier());
      //   }
      prof=pos.Profit();
     }
   return prof;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool mag(int Magic)
  {
   CTrade trade;
   CPositionInfo pos;
   bool m;
   m=false;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;
      m=true;
     }
   return m;
  }
//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
 
bool isNewBar()
  {
//---         
   static datetime last_time=0;
//---  
   datetime lastbar_time=SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);

//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }

//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool CheckNewBar()
  {
//---      
   static datetime new_bar=NULL;
//---       
   static datetime time_last_bar[1]={0};
//---     
//        ,   
   if(CopyTime(_Symbol,Period(),0,1,time_last_bar)==-1)
     { Print(__FUNCTION__,":     : "+IntegerToString(GetLastError())+""); }
//---     
   if(new_bar==NULL)
     {
      //  
      new_bar=time_last_bar[0];
      Print(__FUNCTION__,":  ["+_Symbol+"][TF: "+TimeframeToString(Period())+"]["
            +TimeToString(time_last_bar[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"]");
      return(false); //  false   
     }
//---   
   if(new_bar!=time_last_bar[0])
     {
      new_bar=time_last_bar[0]; //     
      return(true); //     true
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string TimeframeToString(ENUM_TIMEFRAMES timeframe)
  {
   string str="";
//---    ,    
   if(timeframe==WRONG_VALUE|| timeframe== NULL)
      timeframe= Period();
   switch(timeframe)
     {
      case PERIOD_M1  : str="M1";  break;
      case PERIOD_M2  : str="M2";  break;
      case PERIOD_M3  : str="M3";  break;
      case PERIOD_M4  : str="M4";  break;
      case PERIOD_M5  : str="M5";  break;
      case PERIOD_M6  : str="M6";  break;
      case PERIOD_M10 : str="M10"; break;
      case PERIOD_M12 : str="M12"; break;
      case PERIOD_M15 : str="M15"; break;
      case PERIOD_M20 : str="M20"; break;
      case PERIOD_M30 : str="M30"; break;
      case PERIOD_H1  : str="H1";  break;
      case PERIOD_H2  : str="H2";  break;
      case PERIOD_H3  : str="H3";  break;
      case PERIOD_H4  : str="H4";  break;
      case PERIOD_H6  : str="H6";  break;
      case PERIOD_H8  : str="H8";  break;
      case PERIOD_H12 : str="H12"; break;
      case PERIOD_D1  : str="D1";  break;
      case PERIOD_W1  : str="W1";  break;
      case PERIOD_MN1 : str="MN1"; break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
